<?xml version="1.0" encoding="utf-8"?>
<s:Group xmlns:fx="http://ns.adobe.com/mxml/2009" 
		 xmlns:s="library://ns.adobe.com/flex/spark" 
		 xmlns:mx="library://ns.adobe.com/flex/mx"
		 xmlns:visual="br.com.desenv.framework.component.visual.*">

	<fx:Metadata>
		[Event(name="ContaContabilSelecionado", type="mx.rpc.events.ResultEvent")]
	</fx:Metadata>
	

	
	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			import mx.managers.PopUpManager;
			import mx.utils.StringUtil;
			
			import br.com.desenv.nepalign.view.component.ContaContabilComponenteListaPaginada;
			import br.com.desenv.nepalign.vo.ContaContabil;
			import br.com.desenv.nepalign.vo.Page;
			
			[Bindable]
			public var contaContabil:ContaContabil;
			
			public var contaContabilFiltro:ContaContabil = new ContaContabil();
			
			override public function get width():Number 
			{
				return ignTextInputContaContabil.width;
			}
			
			override public function set width(value:Number):void
			{
				super.width = value;
				
				callLater(function():void
				{
					ignTextInputContaContabil.width = value;	
				});
			}
			
			public function set obrigatorio(value:Boolean):void
			{
				callLater(function():void
				{
					ignTextInputContaContabil.obrigatorio = value;	
				});
			}
			
			public function get obrigatorio():Boolean
			{
				return ignTextInputContaContabil.obrigatorio;
			}

			protected function ignTextInputContaContabil_keyDownHandler(event:KeyboardEvent):void
			{
				if(event.keyCode == Keyboard.ENTER ||event.keyCode == Keyboard.NUMPAD_ENTER)
				{
					if(ignTextInputContaContabil.text != "")
					{
						if(contaContabil != null && contaContabil.nomeConcatenado == ignTextInputContaContabil.text) // JA SELECIONADO
							return;
						
						contaContabilFiltro.codigoContabil = null;
						contaContabilFiltro.descricao = null;
						
						if(Number(StringUtil.trim(ignTextInputContaContabil.text).replace(".", "")) != 0 && !isNaN(Number(StringUtil.trim(ignTextInputContaContabil.text).replace(".", ""))))
							contaContabilFiltro.codigoContabil = "%" + StringUtil.trim(ignTextInputContaContabil.text) + "%";
						else
							contaContabilFiltro.descricao = "%" + ignTextInputContaContabil.text + "%";
						
						AMFConnector.instance.prepararObjetoRemoto("contaContabilService", recuperarContaContabilResultHandler).getOperation("listarPorObjetoFiltro").send(contaContabilFiltro);
					}
				}
			}
			
			protected function recuperarContaContabilResultHandler(event:ResultEvent):void
			{
				var listaContaContabil:ArrayCollection = event.result as ArrayCollection;
				
				if(listaContaContabil.length == 0x00)
				{
					dispatchEvent(new ResultEvent("ContaContabilSelecionado", false, true, null, null, null));
					ignTextInputContaContabil.text = "";
				}
				else if(listaContaContabil.length == 0x01)
				{
					contaContabil = listaContaContabil.getItemAt(0x00) as ContaContabil;
					dispatchEvent(new ResultEvent("ContaContabilSelecionado", false, true, contaContabil as ContaContabil, null, null));
					ignTextInputContaContabil.text = "";
				}
				else
				{
					var contaContabilComponenteLista:ContaContabilComponenteListaPaginada = new ContaContabilComponenteListaPaginada();
					contaContabilComponenteLista.objetoFiltro = contaContabilFiltro;
					
					var page:Page = new Page();
					page.totalRecords = listaContaContabil.length;
					
					var recordList:ArrayCollection = new ArrayCollection();
					
					for(var i:int = 0; i < (listaContaContabil.length > 15 ? 15 : listaContaContabil.length); i++)
					{
						recordList.addItem(listaContaContabil.getItemAt(i));
					}
					
					page.recordList = recordList;
					page.pageNumber = 1;
					page.pageSize = 15;
					
					contaContabilComponenteLista.page = page;
					contaContabilComponenteLista.addEventListener("ContaContabilSelecionado", contaContabilSelecionadoResultHandler);
					
					UPCPopUpManager.instance.addPopUp(contaContabilComponenteLista, this, true);
					UPCPopUpManager.instance.centerWindow(contaContabilComponenteLista);
				}
				
			}
			
			protected function contaContabilSelecionadoResultHandler(event:ResultEvent):void
			{
				dispatchEvent(new ResultEvent("ContaContabilSelecionado", false, true, event.result, null, null));
				ignTextInputContaContabil.text = "";
			}
			
			protected function ignTextInputContaContabil_focusOutHandler(event:FocusEvent):void
			{
				if(ignTextInputContaContabil.text == "")
					contaContabil = null;
			}
			
		]]>
	</fx:Script>	
	
	<mx:Grid>
		<mx:GridRow>
			<mx:GridItem>
				<mx:HBox>
					<visual:IgnTextInput id="ignTextInputContaContabil" focusOut="ignTextInputContaContabil_focusOutHandler(event)" keyDown="ignTextInputContaContabil_keyDownHandler(event)"/>
				</mx:HBox>
			</mx:GridItem>
		</mx:GridRow>
	</mx:Grid>
</s:Group>
